-- This is a script that I'm not much proud of (considering hardly any of it is mine), and at the same time, has given me no end of headaches. I've mixed up code from about three different sources here just to get the damned drone to delete its weapons if they're dropped and restore them to its inventory in the same circumstances. Considering how little Lua experience I have, this thing that should've been so simple has turned out to be a nightmare I desperately want to escape.
-- Credits to:
--  Bad Boy, help getting started on the weapon restore code.
--  N0_0NE (Cannot confirm name, but prefer miscredit than no credit), for more specialized weapon restore/deletion code.

function Create(self)

	if not self:HasObject("AM400A Railgun") then
		self.DroneGun = CreateHDFirearm("AM400A Railgun")
		self:AddInventoryItem(self.DroneGun)
	end
	
	if not self:HasObject("RD9100U Convergence Emitter") then
		self.PulseEmitter = CreateHDFirearm("RD9100U Convergence Emitter")
		self:AddInventoryItem(self.PulseEmitter);
	end
	
	self:EquipFirearm(true);
	
end

function Update(self)

   if self.EquippedItem ~= nil then
      if self.EquippedItem.PresetName ~= "AM400A Railgun" and self.EquippedItem.PresetName ~= "RD9100U Convergence Emitter" then -- Is the item equipped supposed to be on the drone?
			if self.Health < 100 then -- Is the drone damaged?
				self.Health = math.min(self.Health + self.EquippedItem.Mass * .5 + 1, 100) -- Check the mass of the acquired item, then convert half of it to health. Add 1 HP to the end result to ensure very light objects (notably grenades) still grant a consolation prize.
				self.HealSound = CreateAEmitter("IMWD Drone Repair Sound Dummy") -- Heal sound code copied from the IM35L CQRT script.
				self.HealSound.Pos = self.Pos
				self.HealSound.PinStrength = 1000
				MovableMan:AddParticle(self.HealSound);
				local Cross = CreateMOSParticle("Particle Heal Effect", "Base.rte") -- Heal particle code copied from the medic drone.
				if Cross then
					Cross.Pos = self.AboveHUDPos + Vector(0, 4)
					MovableMan:AddParticle(Cross)
				end
			end
		self.EquippedItem.ToDelete = true -- Destroy the item.
		end
		self:EquipFirearm(true)
   end

	if self.Health >= 1 and not self:HasObject("AM400A Railgun") then 	-- Is the drone still alive and without a railgun?
		local newGun = CreateHDFirearm("AM400A Railgun")
		self:AddInventoryItem(newGun); -- Add the new gun.
		self.DroneGun = newGun;
		self:EquipFirearm(true)
	end
	
	if self.Health >= 1 and not self:HasObject("RD9100U Convergence Emitter") then	-- As above, but with the emitter.
		local newEmitter = CreateHDFirearm("RD9100U Convergence Emitter")
		self:AddInventoryItem(newEmitter);
		self.PulseEmitter = newEmitter;
		self:EquipFirearm(true)
	end
	
end

--[[
function Destroy(self)


	self.PulseEmitter:GibThis()


end
]]--