-- A tweak-and-splice like the rifleman's code, but this includes some of my own to set the frame for the medkit based on the user's health. A tiny detail, but it's the little things that make me happy.

function Create(self)
	self.HealTimer = Timer()
	self.HealTimer:SetSimTimeLimitMS(200)
	self.CrossTimer = Timer()
	self.CrossTimer:SetSimTimeLimitMS(800)
end

function Update(self)
   if self.RootID ~= self.ID then
	if self.HealTimer:IsPastSimTimeLimit() then
		self.HealTimer:Reset()

			
			if self.IsActivated then
				-- Start healing
				self.ParentActor = ToActor(MovableMan:GetMOFromID(self.RootID))
				if self.ParentActor ~= nil then
					self.ParentActor.Health = math.min(self.ParentActor.Health+1, 100)
					
					if self.ParentActor.Health >= 90 then
						self.Frame = 0
							else if self.ParentActor.Health < 90 and self.ParentActor.Health >= 75 then
								self.Frame = 1
									else if self.ParentActor.Health < 75 and self.ParentActor.Health >= 50 then
										self.Frame = 2
											else if self.ParentActor.Health < 50 then
												self.Frame = 3
											end
									end
							end
					end
					
				
					-- Draw the healing icon
					if self.CrossTimer:IsPastSimTimeLimit() then
						self.CrossTimer:Reset()
					
						local Cross = CreateMOSParticle("Particle Heal Effect", "Base.rte")
						if Cross then
							Cross.Pos = self.ParentActor.AboveHUDPos + Vector(0, 4)	-- Set the particle's position to just over the actor's head
							MovableMan:AddParticle(Cross)
						end
					end
				end
			end
		end
	end

end
