-- Effectively a tweak-and-splice from the medic drone's code. Took me quite some time to figure out how to check if there's nothing holding it without throwing an error in the process.

function Create(self)
	self.HealTimer = Timer()
	self.HealTimer:SetSimTimeLimitMS(400)
	self.CrossTimer = Timer()
	self.CrossTimer:SetSimTimeLimitMS(1000)
end

function Update(self)
   if self.RootID ~= self.ID then
		if self.HealTimer:IsPastSimTimeLimit() then
			self.HealTimer:Reset()

			
			if self.IsActivated then
				-- Start healing
				self.ParentActor = ToActor(MovableMan:GetMOFromID(self.RootID))
				if self.ParentActor ~= nil then
					self.ParentActor.Health = math.min(self.ParentActor.Health+1, 100)
					-- Draw the healing icon
					if self.CrossTimer:IsPastSimTimeLimit() then
						self.CrossTimer:Reset()
					
						local Cross = CreateMOSParticle("Particle Heal Effect", "Base.rte")
						if Cross then
							Cross.Pos = self.ParentActor.AboveHUDPos + Vector(0, 4)	-- Set the particle's position to just over the actor's head
							MovableMan:AddParticle(Cross)
						end
					end
				end
			end
		end
	end

end
